--
-- Script for Case 1455 by Katsou 
--
--
-- @author:		mx270 (wwww.modding-society.de)
-- @version:	v0.1
-- @date:		26/04/11
--
-- Copyright mx270, wwww.modding-society.de   
-- then self.mouseControls[1].mouseButton = "right" ;


Case1455 = {};

function Case1455.prerequisitesPresent(specializations)
     return true;
end;

function Case1455:load(xmlFile)
	
	self.setLeftDoor = SpecializationUtil.callSpecializationsFunction("setLeftDoor");
	self.setRightDoor = SpecializationUtil.callSpecializationsFunction("setRightDoor");
	self.setWindowback = SpecializationUtil.callSpecializationsFunction("setWindowback");
	self.setWindow = SpecializationUtil.callSpecializationsFunction("setWindow");
	
	local rotationPartNodeLeftDoor= Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.LeftDoor#index"));
    if rotationPartNodeLeftDoor ~= nil then
        self.LeftDoor = {};
        self.LeftDoor.node = rotationPartNodeLeftDoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.LeftDoor#minRot"));
        self.LeftDoor.minRot = {};
        self.LeftDoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.LeftDoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.LeftDoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.LeftDoor#maxRot"));
        self.LeftDoor.maxRot = {};
        self.LeftDoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.LeftDoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.LeftDoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.LeftDoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.LeftDoor#rotTime"), 2)*1000;
    end;
	
	    local rotationPartNodeRightDoor= Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.RightDoor#index"));
    if rotationPartNodeRightDoor ~= nil then
        self.RightDoor = {};
        self.RightDoor.node = rotationPartNodeRightDoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.RightDoor#minRot"));
        self.RightDoor.minRot = {};
        self.RightDoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.RightDoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.RightDoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.RightDoor#maxRot"));
        self.RightDoor.maxRot = {};
        self.RightDoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.RightDoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.RightDoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.RightDoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.RightDoor#rotTime"), 2)*1000;
    end;
	
	    local rotationPartNodeWindowback= Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Windowback#index"));
    if rotationPartNodeWindowback ~= nil then
        self.Windowback = {};
        self.Windowback.node = rotationPartNodeWindowback;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Windowback#minRot"));
        self.Windowback.minRot = {};                                     
        self.Windowback.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Windowback.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Windowback.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Windowback#maxRot"));
        self.Windowback.maxRot = {};
        self.Windowback.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Windowback.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Windowback.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Windowback.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Windowback#rotTime"), 2)*1000;
    end;
	
	local rotationPartNodeWindow= Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Window#index"));
    if rotationPartNodeWindow ~= nil then
        self.Window = {};
        self.Window.node = rotationPartNodeWindow;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Window#minRot"));
        self.Window.minRot = {};
        self.Window.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Window.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Window.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Window#maxRot"));
        self.Window.maxRot = {};
        self.Window.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Window.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Window.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Window.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Window#rotTime"), 2)*1000;
    end;
	
		self.Unterlenker = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Unterlenker#index"));
	
	setRotation(self.Unterlenker, Utils.degToRad(-85), 0, 0);
	
self.LeftDoorOpen = false;
	self.RightDoorOpen = false;
	self.WindowbackOpen = false;
	self.WindowOpen = false;
	
	self.change = 1;

	
end;

function Case1455:delete()
end;

function Case1455:mouseEvent(posX, posY, isDown, isUp, button)

end;

function Case1455:keyEvent(unicode, sym, modifier, isDown)
end;

function Case1455:readStream(streamId, connection)
     self:setLeftDoor(streamReadBool(streamId), true);
	 self:setRightDoor(streamReadBool(streamId), true);
	 self:setWindowback(streamReadBool(streamId), true);
	 self:setWindow(streamReadBool(streamId), true);
end;

function Case1455:writeStream(streamId, connection)
    streamWriteBool(streamId, self.LeftDoorOpen);
	streamWriteBool(streamId, self.RightDoorOpen);
	streamWriteBool(streamId, self.WindowbackOpen);
    streamWriteBool(streamId, self.WindowOpen);
end;

function Case1455:update(dt)
	 if self:getIsActiveForInput() then
 if InputBinding.hasEvent(InputBinding.CHANGE) then
self.change = self.change + 1;
end;

if self.change > 4 then
self.change = 1;
end;

     if InputBinding.hasEvent(InputBinding.OPEN) then
        if self.change == 1 then
  self:setLeftDoor(not self.LeftDoorOpen);
        elseif self.change == 2 then
   self:setRightDoor(not self.RightDoorOpen);
        elseif self.change == 3 then
self:setWindowback(not self.WindowbackOpen) ;
        elseif self.change == 4 then
    self:setWindow(not self.WindowOpen);
    end;

end;
end;
	
	 if self.attacherJoints[2].jointIndex ~= 0 then
setRotation(self.Unterlenker, Utils.degToRad(0), 0, 0);
else
setRotation(self.Unterlenker, Utils.degToRad(-85), 0, 0);
end;
			
end;

function Case1455:updateTick(dt)

	
if self.LeftDoor ~= nil then
		local x, y, z = getRotation(self.LeftDoor.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.LeftDoor.maxRot, self.LeftDoor.minRot, 3, self.LeftDoor.rotTime, dt, not self.LeftDoorOpen);
		setRotation(self.LeftDoor.node, unpack(newRot));
   end;
   
   	if self.RightDoor ~= nil then
		local x, y, z = getRotation(self.RightDoor.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.RightDoor.maxRot, self.RightDoor.minRot, 3, self.RightDoor.rotTime, dt, not self.RightDoorOpen);
		setRotation(self.RightDoor.node, unpack(newRot));
   end;
   
   if self.Windowback ~= nil then
		local x, y, z = getRotation(self.Windowback.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Windowback.maxRot, self.Windowback.minRot, 3, self.Windowback.rotTime, dt, not self.WindowbackOpen);
		setRotation(self.Windowback.node, unpack(newRot));
   end;
   
   	if self.Window ~= nil then
		local x, y, z = getRotation(self.Window.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Window.maxRot, self.Window.minRot, 3, self.Window.rotTime, dt, not self.WindowOpen);
		setRotation(self.Window.node, unpack(newRot));
   end;
   
    
			 
end;

function Case1455:setLeftDoor(DoorLeft, noEventSend)
    LeftDoorEvent.sendEvent(self, DoorLeft, noEventSend);
    self.LeftDoorOpen = DoorLeft; 
end;

function Case1455:setRightDoor(DoorRight, noEventSend)
  RightDoorEvent.sendEvent(self, DoorRight, noEventSend);
    self.RightDoorOpen = DoorRight; 
end;

function Case1455:setWindowback(BackWindow, noEventSend)
  WindowbackEvent.sendEvent(self, BackWindow, noEventSend);
    self.WindowbackOpen = BackWindow; 
end;

function Case1455:setWindow(Window, noEventSend)
  WindowEvent.sendEvent(self, Window, noEventSend);
    self.WindowOpen = Window; 
end;



function Case1455:draw()
	
	if self.change == 1 then
	if self.LeftDoorOpen then
	 g_currentMission:addHelpButtonText(string.format(g_i18n:getText("LeftDoorClose"), self.typeDesc), InputBinding.OPEN);
		 else
       g_currentMission:addHelpButtonText(string.format(g_i18n:getText("LeftDoorOpen"), self.typeDesc), InputBinding.OPEN);
    end;
	end;
	
	if self.change == 2 then
		if self.RightDoorOpen then
		 g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RightDoorClose"), self.typeDesc), InputBinding.OPEN);
		else
      g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RightDoorOpen"), self.typeDesc), InputBinding.OPEN); 
    end;
	end;
	
	if self.change == 3	then
		if self.WindowbackOpen then
		  g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WindowbackClose"), self.typeDesc), InputBinding.OPEN);
		else
      g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WindowbackOpen"), self.typeDesc), InputBinding.OPEN);
    end;
	end;
	
	if self.change == 4 then
	if self.WindowOpen then
    g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WindowClose"), self.typeDesc), InputBinding.OPEN);
    else
	g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WindowOpen"), self.typeDesc), InputBinding.OPEN);
    end;
	end;
	
	g_currentMission:addHelpButtonText(g_i18n:getText("Wechseln"), InputBinding.CHANGE);
end;

